pro do_skysub_indivframe,refimage,specimage,refimage_ss,specimage_ss, $
                         refimage_short,specimage_short,refimage_ss_short,specimage_ss_short, $
                         weight_spec_long=weight_spec_long,weight_ref_long=weight_ref_long, $
                         weight_spec_short=weight_spec_short,weight_ref_short=weight_ref_short, $
                         specmask=specmask,imagmask=imagmask,source_table=source_table,objmask=objmask,dx=dx,dy=dy

  common gui,logger

  if    !IRC_SPECRED_OBSPARAM.slit_mode $
     || !IRC_SPECRED_OBSPARAM.Np_mode $
     || !IRC_SPECRED_OBSPARAM.preflight_mode $
  then begin
     refimage_ss=refimage
     specimage_ss=specimage
     refimage_ss_short=refimage_short
     specimage_ss_short=specimage_short
     return
  endif

  logger->append,[['---','Sky-subtracting (global) from all subframes...']]

  irc_skysub_indivframe,specimage,specimage_ss, $
                        weight=weight_spec_long,mask=specmask,source_table=source_table, $
                        objmask=objmask,dx=dx,dy=dy,outmask=outmask

  irc_skysub_indivframe,refimage, refimage_ss, $
                        weight=weight_ref_long,mask=imagmask,source_table=source_table,/imag

  irc_skysub_indivframe,specimage_short,specimage_ss_short,weight=weight_spec_short, $
                        mask=specmask,/short,source_table=source_table
  irc_skysub_indivframe,refimage_short,refimage_ss_short,weight=weight_ref_short,/short, $
                        mask=imagmask,source_table=source_table,/imag

; column pull down correction for MIRs

  if (MIRS() || MIRL()) && !IRC_SPECRED_PROCESSOPTION.mir_column_pulldown_correction_mode EQ 1B then begin
     correct_mir_columnpulldown,specimage_ss,specimage_ss_pulldown,mask=outmask,dx=dx,dy=dy & specimage_ss=specimage_ss_pulldown
     correct_mir_columnpulldown,refimage_ss,refimage_ss_pulldown & refimage_ss=refimage_ss_pulldown
  endif

  if defined(outmask) then specmask=outmask

end
