pro write_all_output,source_table,space_profile,spec_profile,wave_array,specimage_fc_1d, $
                     refimage_bg,specimage_bg, $
                     refimage_n,refimage_n_short, $
                     specimage_n_sff,specimage_n_sff_short, $
                     specimage_n_wc,specimage_n_wc_short, $
                     specimage_n_fc,specimage_n_fc_short, $
                     res_refimage_bg,res_specimage_bg, $
                     mask_refimage,mask_specimage,mask_specimage_n,$
                     imagheader,specheader,imagheader_extract,specheader_extract, $
                     noisemap,noisemap_n,noisemap_short_n,noise_mask, $
                     dir=dir,image_4d=image_4d,savefile=savefile
  common gui,logger

  get_prefix,dir,prefix

; output log
  log=logger->gettext()
  writecol,prefix+'.log',log,fmt='A'

; tweaking headers
  imagheader=imagheader[*,0]
  specheader=specheader[*,0]
  
  imagheader_whole=imagheader & sxdelpar,imagheader_whole,'NAXIS3'
  specheader_whole=specheader & sxdelpar,specheader_whole,'NAXIS3'

; check headers
  check_fits,refimage_bg,imagheader_whole,/update,/silent
  check_fits,specimage_bg,specheader_whole,/update,/silent
  
  check_fits,refimage_n,imagheader,/update,/silent
  check_fits,specimage_n_wc,specheader,/update,/silent

;;; Write FITS images

  if defined(image_4d) then begin
     s=size(image_4d) & n_subframe=s[4]
     for subframe_id=0,n_subframe-1 do begin
        mwrfits,image_4d[*,*,*,subframe_id],prefix+ '.specimage_wc_indiv_frame'+strim(subframe_id)+'.fits',specheader,/create
     endfor
  endif


; whole image products
  mwrfits,refimage_bg,prefix+ '.refimage_bg.fits',imagheader_whole,/create
  mwrfits,specimage_bg,prefix+'.specimage_bg.fits',specheader_whole,/create

  if !IRC_SPECRED_PROCESSOPTION.AUTO_IMAGE_STACK EQ 1B then return

  mwrfits,res_refimage_bg,prefix+ '.residual_refimage_bg.fits',imagheader_whole,/create
  mwrfits,res_specimage_bg,prefix+'.residual_specimage_bg.fits',imagheader_whole,/create

  mwrfits,mask_refimage,prefix+ '.refimage_mask.fits',imagheader_whole,/create
  mwrfits,mask_specimage,prefix+'.specimage_mask.fits',specheader_whole,/create

  mwrfits,noisemap,prefix+'.specimage_noisemap.fits',specheader_whole,/create
  mwrfits,noise_mask,prefix+'.specimage_noisemask.fits',specheader_whole,/create

; extracted image products
  mwrfits,refimage_n,prefix+    '.refimage_bg_indiv.fits',imagheader,/create
  mwrfits,specimage_n_wc,prefix+'.specimage_wc_indiv.fits',specheader,/create
  mwrfits,specimage_n_fc,prefix+'.specimage_fc_indiv.fits',specheader,/create
  
  mwrfits,mask_specimage_n,prefix+    '.specimage_mask_indiv.fits',specheader,/create

  mwrfits,noisemap_n,prefix+    '.specimage_noisemap_indiv.fits',specheader,/create

;  write (and read) ascii spectra
;  write_spec,wave_array,specimage_fc_1d
;  read_spec,wave_array,specimage_fc_1d

; Write a catalog file
  write_target_table,source_table,prefix=prefix;,dir=dir
  write_source_table,source_table,prefix=prefix;,dir=dir

;  write_profile,space_profile,dir=dir,filename=prefix+'.space1Dprof.dat'
;  write_profile,spec_profile,dir=dir,filename=prefix +'.spec1Dprof.dat'

;  mwrfits,badpixelimage_image,strcompress(prefix+'.badpiximage.fits',/remove_all)
;  mwrfits,badpixelimage_spec,strcompress(prefix+'.badpixspecimage.fits',/remove_all)

; region files
  regionfilename=prefix+'.refimage.reg'
  write_ds9_region_file,source_table,filename=regionfilename,/IMAG
  regionfilename=prefix+'.specimage.reg'
  write_ds9_region_file,source_table,filename=regionfilename

; putwcs
  if !IRC_SPECRED_PROCESSOPTION.putwcs_mode EQ 1B && ~ LG2() then put_wcs,refimage_bg,imagheader_whole,prefix

; create IDL save file
  savefile=prefix+'.IRC_SPECRED_OUT.sav'
  save,source_table,source_id,wave_array, $
       refimage_bg,specimage_bg, $
       refimage_n,refimage_n_short, $
       specimage_n_sff,specimage_n_sff_short, $
       specimage_n_wc,specimage_n_wc_short, $
       res_refimage_bg,res_specimage_bg, $
       mask_refimage,mask_specimage,mask_specimage_n, $
       imagheader,specheader,imagheader_extract,specheader_extract, $
       noisemap,noisemap_n,noisemap_short_n,noise_mask, $
       /system,/comm,/variable,filename=savefile;,/ver

end
